代码改变世界

hdu 1258 Sum It Up

2012-04-01 17:13  璋廊  阅读(317)  评论(0编辑  收藏  举报

http://acm.hdu.edu.cn/showproblem.php?pid=1258

Problem Description
Given a specified total t and a list of n integers, find all distinct sums using numbers from the list that add up to t. For example, if t=4, n=6, and the list is [4,3,2,2,1,1], then there are four different sums that equal 4: 4,3+1,2+2, and 2+1+1.(A number can be used within a sum as many times as it appears in the list, and a single number counts as a sum.) Your job is to solve this problem in general.
 

 

Input
The input will contain one or more test cases, one per line. Each test case contains t, the total, followed by n, the number of integers in the list, followed by n integers x1,...,xn. If n=0 it signals the end of the input; otherwise, t will be a positive integer less than 1000, n will be an integer between 1 and 12(inclusive), and x1,...,xn will be positive integers less than 100. All numbers will be separated by exactly one space. The numbers in each list appear in nonincreasing order, and there may be repetitions.
 

 

Output
For each test case, first output a line containing 'Sums of', the total, and a colon. Then output each sum, one per line; if there are no sums, output the line 'NONE'. The numbers within each sum must appear in nonincreasing order. A number may be repeated in the sum as many times as it was repeated in the original list. The sums themselves must be sorted in decreasing order based on the numbers appearing in the sum. In other words, the sums must be sorted by their first number; sums with the same first number must be sorted by their second number; sums with the same first two numbers must be sorted by their third number; and so on. Within each test case, all sums must be distince; the same sum connot appear twice.
 

 

Sample Input
4 6 4 3 2 2 1 1 5 3 2 1 1 400 12 50 50 50 50 50 50 25 25 25 25 25 25 0 0
 

 

Sample Output
Sums of 4:
4
3+1
2+2
2+1+1
Sums of 5:
NONE
Sums of 400:
50+50+50+50+50+50+25+25+25+25
50+50+50+50+50+25+25+25+25+25+25
题目描述:给你一个数t作为最后等式的和,并给你一组数a[i](i<12)作为等式的加数,每个加数最多只能使用一次,要求输出所有满足条件(加数从大到小输出)的等式,并且不能重复。
例:t=4. a[]={4,3,2,2,1,1}
输出 4,3+1,2+2,2+1+1
解题思路:题目要求输出从大到小输出,所以可以先给所有的数进行降序排序。数据的规模很小,所以可以用暴力搜索。搜索过程中,为了避免重复输出,需要记录前一层搜索的起点,下一层递归搜索的起点不能与前一层记录的点一样...说不清楚,具体见代码
#include<stdio.h>
#include<stdlib.h>
int a[13],sum1[13];
int cmp(const void *a,const void *b)
{
	return *(int*)b-*(int*)a;
}
int t,n;
int flag;
void dfs(int sum ,int k,int g)
{
	int i;
	if(sum>t)
		return ;
	if(sum==t)
	{
		flag=1;
	for(i=0;i<g-1;i++)
	{
		printf("%d+",sum1[i]);
	}
	printf("%d\n",sum1[g-1]);
	return ;
	}
	int last=-1;
	for(i=k;i<n;i++)
	{
		if(a[i]!=last)//为了避免搜的数与上一次重复;
		{
		sum1[g++]=a[i];
		last=a[i];
		dfs(sum+a[i],i+1,g);
			g--;
		}
	}
	return ;
}
int main()
{
	int i,h;
	while(scanf("%d%d",&t,&n),t+n)
	{
		h=0;
		flag=0;
		for(i=0;i<n;i++)
			scanf("%d",&a[i]);
		qsort(a,n,sizeof(a[0]),cmp);
		printf("Sums of %d:\n",t);
		dfs(0,0,0);
		if(!flag)
			printf("NONE\n");
	}
	return 0;
}